# AUTOGENERATED! DO NOT EDIT! File to edit: src/value.ipynb (unless otherwise specified).

__all__ = ['Value']


# Cell
from typing import Dict
#from .instance import Instance # causes circular import

class Value:
    def __init__(self, name: str, confidence: float, importances : Dict= None ):
        if importances is None:
            self.importances = dict({'__all__':1})
        else:
            self.importances = importances
            
        self.confidence = confidence
        self.name = name

    def get_name(self) -> str:
        return self.name
    
    #TODO: circular import makes it a mess, so no Instance definition here
    def compile_expr(self, i) -> 'Value':
        readings = i.get_readings()
        expr = self.get_name()
        for key in sorted(readings.keys(),key=len,reverse=True):
            expr = expr.replace(key, readings[key].get_most_probable().get_name())
        return expr

    def get_confidence(self) -> float:
        return self.confidence
    
    def get_importances(self) -> Dict:
        return self.importances
    
    def get_importance_for_class(class_label:str) -> float:
        return importances[class_label]

    def __str__(self) -> str:
        return self.get_name() + '[' + str(round(self.get_confidence() * 100.0) / 100.0) + ']'

    def __eq__(self, other: 'Value') -> bool:
        return self.name == other.get_name()
